/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.44 from the
 * contents of AtFork.xs. Do not edit this file, edit AtFork.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "AtFork.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <pthread.h>

#define MY_CXT_KEY "POSIX::AtFork::_guts" XS_VERSION
typedef struct {
    AV* prepare_list;
    AV* parent_list;
    AV* child_list;
} my_cxt_t;
START_MY_CXT

typedef struct {
    PERL_SI *curstackinfo;
    AV *curstack;
    AV *mainstack;
    SV **stack_base;
    SV **stack_sp;
    SV **stack_max;
} stack_backup_t;

static void
paf_save_stacks(pTHX_ stack_backup_t* bk) {
    bk->curstackinfo = PL_curstackinfo;
    bk->curstack = PL_curstack;
    bk->mainstack = PL_mainstack;

    bk->stack_base = PL_stack_base;
    bk->stack_sp = PL_stack_sp;
    bk->stack_max = PL_stack_max;
}

static void
paf_restore_stacks(pTHX_ stack_backup_t* bk) {
    PL_curstackinfo = bk->curstackinfo;
    PL_curstack = bk->curstack;
    PL_mainstack = bk->mainstack;

    PL_stack_base = bk->stack_base;
    PL_stack_sp = bk->stack_sp;
    PL_stack_max = bk->stack_max;
}

static void
paf_init_stacks(pTHX) {
    PL_curstackinfo = new_stackinfo(32, 4);
    PL_curstackinfo->si_type = PERLSI_MAIN;
    PL_curstack = PL_curstackinfo->si_stack;
    PL_mainstack = PL_curstack;

    PL_stack_base = AvARRAY(PL_curstack);
    PL_stack_sp = PL_stack_base;
    PL_stack_max = PL_stack_base + AvMAX(PL_curstack);
}

static void
paf_destruct_stacks(pTHX) {
    while (PL_curstackinfo->si_next)
        PL_curstackinfo = PL_curstackinfo->si_next;

    while (PL_curstackinfo) {
        PERL_SI *p = PL_curstackinfo->si_prev;

        if (!PL_dirty)
            SvREFCNT_dec (PL_curstackinfo->si_stack);

        Safefree (PL_curstackinfo->si_cxstack);
        Safefree (PL_curstackinfo);
        PL_curstackinfo = p;
    }
}

static void
paf_call_list(pTHX_ AV* const av) {
    const char* const opname = PL_op ? OP_NAME(PL_op) : "(unknown)";
    SV* opnamesv;
    I32 const len = av_len(av) + 1;
    I32 i;

    stack_backup_t bk;
    paf_save_stacks(aTHX_ &bk);
    paf_init_stacks(aTHX);
    ENTER;
    SAVETMPS;
    opnamesv = sv_2mortal(newSVpv(opname, 0));
    for(i = 0; i < len; i++) {
        dSP;
        PUSHMARK(SP);
        XPUSHs(opnamesv);
        PUTBACK;
        call_sv(*av_fetch(av, i, TRUE), G_VOID | G_EVAL);
        if(SvTRUEx(ERRSV)) {
            warn("Callback for pthread_atfork() died (ignored): %"SVf,
                ERRSV);
        }
    }
    FREETMPS;
    LEAVE;
    paf_destruct_stacks(aTHX);
    paf_restore_stacks(aTHX_ &bk);
}

static void
paf_prepare(void) {
    dTHX;
    dMY_CXT;
    paf_call_list(aTHX_ MY_CXT.prepare_list);
}

static void
paf_parent(void) {
    dTHX;
    dMY_CXT;
    paf_call_list(aTHX_ MY_CXT.parent_list);
}

static void
paf_child(void) {
    dTHX;
    dMY_CXT;
    SV* pidsv;

    /* fix up pid */
    pidsv = get_sv("$", GV_ADD);
    SvREADONLY_off(pidsv);
    sv_setiv(pidsv, (IV)PerlProc_getpid());
    SvREADONLY_on(pidsv);

    paf_call_list(aTHX_ MY_CXT.child_list);
}

static void
paf_register_cb(pTHX_ AV* const list, SV* const cb) {
    SvGETMAGIC(cb);
    if(SvOK(cb)) {
        if(SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV) {
            av_push(list, newSVsv(cb));
        }
        else {
            croak("Callback for atfork must be a CODE reference");
        }
    }
}

static void
paf_delete(pTHX_ AV* const av, SV* const cb) {
    I32 len = av_len(av) + 1;
    I32 i;

    if(!(SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV)) {
        croak("Not a CODE reference to delete callbacks");
    }

    for(i = 0; i < len; i++) {
        SV* const sv = *av_fetch(av, i, TRUE);
        if(!SvROK(sv)){ sv_dump(sv); }
        assert(SvROK(sv));

        if(SvRV(sv) == SvRV(cb)) {
            size_t const tail = len - i - 1;
            Move(AvARRAY(av) + i + 1, AvARRAY(av) + i, tail, SV*);
            AvFILLp(av)--;
            len--;
            SvREFCNT_dec(sv);
        }
    }
}

static void
paf_initialize(pTHX_ pMY_CXT_ bool const cloning PERL_UNUSED_DECL) {
    pthread_atfork(paf_prepare, paf_parent, paf_child);

    MY_CXT.prepare_list = newAV();
    MY_CXT.parent_list  = newAV();
    MY_CXT.child_list   = newAV();
}

#line 193 "AtFork.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 337 "AtFork.c"
#ifdef USE_ITHREADS
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_POSIX__AtFork_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 198 "AtFork.xs"
{
    MY_CXT_CLONE;
    paf_initialize(aTHX_ aMY_CXT_ TRUE);
    PERL_UNUSED_VAR(items);
}
#line 355 "AtFork.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_POSIX__AtFork_pthread_atfork); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_pthread_atfork)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "prepare, parent, child");
    {
	SV*	prepare = ST(0)
;
	SV*	parent = ST(1)
;
	SV*	child = ST(2)
;
#line 209 "AtFork.xs"
{
   dMY_CXT;
   paf_register_cb(aTHX_ MY_CXT.prepare_list, prepare);
   paf_register_cb(aTHX_ MY_CXT.parent_list,  parent);
   paf_register_cb(aTHX_ MY_CXT.child_list,   child);
}
#line 382 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_add_to_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_add_to_prepare)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 220 "AtFork.xs"
{
   dMY_CXT;
   paf_register_cb(aTHX_ MY_CXT.prepare_list, cb);
}
#line 402 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_add_to_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_add_to_parent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 229 "AtFork.xs"
{
   dMY_CXT;
   paf_register_cb(aTHX_ MY_CXT.parent_list, cb);
}
#line 422 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_add_to_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_add_to_child)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 238 "AtFork.xs"
{
   dMY_CXT;
   paf_register_cb(aTHX_ MY_CXT.child_list, cb);
}
#line 442 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_delete_from_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_delete_from_prepare)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 246 "AtFork.xs"
{
    dMY_CXT;
    paf_delete(aTHX_ MY_CXT.prepare_list, cb);
}
#line 462 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_delete_from_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_delete_from_parent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 254 "AtFork.xs"
{
    dMY_CXT;
    paf_delete(aTHX_ MY_CXT.parent_list, cb);
}
#line 482 "AtFork.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__AtFork_delete_from_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__AtFork_delete_from_child)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "klass, cb");
    {
	SV*	cb = ST(1)
;
#line 262 "AtFork.xs"
{
    dMY_CXT;
    paf_delete(aTHX_ MY_CXT.child_list, cb);
}
#line 502 "AtFork.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_POSIX__AtFork); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_POSIX__AtFork)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

#if XSubPPtmpAAAA
        newXS_deffile("POSIX::AtFork::CLONE", XS_POSIX__AtFork_CLONE);
#endif
        newXS_deffile("POSIX::AtFork::pthread_atfork", XS_POSIX__AtFork_pthread_atfork);
        newXS_deffile("POSIX::AtFork::add_to_prepare", XS_POSIX__AtFork_add_to_prepare);
        newXS_deffile("POSIX::AtFork::add_to_parent", XS_POSIX__AtFork_add_to_parent);
        newXS_deffile("POSIX::AtFork::add_to_child", XS_POSIX__AtFork_add_to_child);
        newXS_deffile("POSIX::AtFork::delete_from_prepare", XS_POSIX__AtFork_delete_from_prepare);
        newXS_deffile("POSIX::AtFork::delete_from_parent", XS_POSIX__AtFork_delete_from_parent);
        newXS_deffile("POSIX::AtFork::delete_from_child", XS_POSIX__AtFork_delete_from_child);

    /* Initialisation Section */

#line 188 "AtFork.xs"
{
    MY_CXT_INIT;
    paf_initialize(aTHX_ aMY_CXT_ FALSE);
}

#if XSubPPtmpAAAA
#endif
#line 556 "AtFork.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

